stages:
- update
- build
- deploy

update:     # runs pipeline as scheduled: https://gitlab.com/FelixFranz/FHWS/smart-contract-generation/generator/pipeline_schedules
  stage: update
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
  - mkdir -p ~/.ssh
  # install ssh key for public key
  - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
  - echo -e $GITLAB_CI_DEPLOY_KEY > ~/.ssh/id_rsa
  - chmod 700 ~/.ssh/id_rsa
  # remove token from git repository url
  - export CI_PUSH_REPO=$(echo "git@gitlab.com:"$(echo $CI_REPOSITORY_URL | grep -oP "^.*:\/\/.+:.+@gitlab.com/\K(.+)$") )
  - echo "CI_PUSH_REPO=$CI_PUSH_REPO"
  - git remote set-url --push origin "${CI_PUSH_REPO}"
  # added git settings
  - git config --global user.name "Gitlab Runner"
  - git config --global user.email "runner@gitlab.com"
  script:
  - git checkout master
  - git submodule update --recursive --remote
  - git add --all
  - git commit -m "Updated backend" || echo "" > /dev/null
  - git push
  only:
  - schedules
  - triggers

build:
  image: docker:git
  stage: build
  retry: 2
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  services:
  - docker:dind
  before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  script:
  # if A tag was created
  - |
    [[ "${CI_COMMIT_TAG}" ]] && TAG=$(echo $CI_COMMIT_TAG | sed -r 's/release\///g') && TAG_VERSION=$TAG
  # if NO tag was created
  - |
    [[ "${CI_COMMIT_TAG}" ]] || TAG=latest && TAG_VERSION=0.0.0
  - sed -i "s/<GENERATOR_VERSION>/$TAG_VERSION/g" package.json
  - docker build -t registry.gitlab.com/felixfranz/fhws/smart-contract-generation/generator:$TAG .
  - docker push registry.gitlab.com/felixfranz/fhws/smart-contract-generation/generator:$TAG
  only:
  - master
  - tags
  except:
  - schedules
  
deploy_npmregistry:
  image: node
  stage: deploy
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  before_script:
  - echo "//registry.npmjs.org/:_authToken=$npm_token" > ~/.npmrc
  script:
  - TAG=$(echo $CI_COMMIT_TAG | sed -r 's/release\///g')
  - sed -i "s/<GENERATOR_VERSION>/$TAG/g" package.json
  - npm publish
  only:
  - tags
  
deploy_dockerhub:
  image: docker:git
  stage: deploy
  variables:
    GIT_STRATEGY: none
    GIT_SUBMODULE_STRATEGY: none
  services:
  - docker:dind
  before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  - docker login -u $dockerhub_username -p $dockerhub_password
  script:
  - TAG=$(echo $CI_COMMIT_TAG | sed -r 's/release\///g')
  - docker pull registry.gitlab.com/felixfranz/fhws/smart-contract-generation/generator:$TAG
  - docker tag registry.gitlab.com/felixfranz/fhws/smart-contract-generation/generator:$TAG felixfranz/smart-contract-generator:$TAG
  - docker tag felixfranz/smart-contract-generator:$TAG felixfranz/smart-contract-generator:latest
  - docker push felixfranz/smart-contract-generator:$TAG
  - docker push felixfranz/smart-contract-generator:latest
  only:
  - tags
  
.deploy_server:
  stage: deploy
  variables:
    GIT_STRATEGY: none
    GIT_SUBMODULE_STRATEGY: none
  before_script:
  - mkdir -p ~/.ssh
  - ssh-keyscan -p 8080 generator.felix-franz.com >> ~/.ssh/known_hosts
  - echo -e $FHWS_VM_SSH_PRIVATEKEY > ~/.ssh/id_rsa
  - chmod 700 ~/.ssh/id_rsa
  script:
  - ssh -p 8080 $FHWS_VM_USER@$FHWS_VM_ADDRESS "
    	sudo docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com;
    	sudo docker pull registry.gitlab.com/felixfranz/fhws/smart-contract-generation/generator:latest;
        sudo docker stop generator;
    	sudo docker rm generator;
    	sudo docker run -p 5000:8080 -d --name generator registry.gitlab.com/felixfranz/fhws/smart-contract-generation/generator:latest"
  only:
  - master
  except:
  - schedules
  - triggers
  environment:
    name: FHWS Server
    url: https://generator.felix-franz.com
